/**************************************************************************
 *    file:         talkserverDlg.cpp                                     *
 *    create:       June 9, 2000                                          *
 *    copyright:    @ 2000, by Zhaohui Xing                               *
 *    e-mail:       xinghh@yahoo.com                                      * 
 *    description:  implementation of CTalkserverDlg class                *
 **************************************************************************/
#include "stdafx.h"
#include "talkserver.h"
#include "talkserverDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/**************************************************************************
 *                                                                        *
 * CAboutDlg dialog used for App About                                    *
 *                                                                        *
 **************************************************************************/
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/**************************************************************************
 *                                                                        *
 * CTalkserverDlg dialog                                                  *
 *                                                                        *
 **************************************************************************/
CTalkserverDlg::CTalkserverDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTalkserverDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTalkserverDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_iNextFree = 0;
	m_iMaxConnects = 5;
    m_iWorkProt = 0;
	m_vtMsgBuf = new VTMSG; 
	memset((void*)m_vtMsgBuf, 0, sizeof(SIZEVTMSG));
}

CTalkserverDlg::~CTalkserverDlg()
{
}

void CTalkserverDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTalkserverDlg)
	DDX_Control(pDX, IDC_CLIENT, m_ClientList);
	DDX_Control(pDX, IDC_PROTOCOL, m_ProtList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTalkserverDlg, CDialog)
	//{{AFX_MSG_MAP(CTalkserverDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
 	ON_MESSAGE(VTM_CONNECTED, OnVTConnected)
 	ON_MESSAGE(VTM_DATAREADY, OnVTDataReady)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/**************************************************************************
 *  Initialize the dialogbox                                              *
 **************************************************************************/
BOOL CTalkserverDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	// Initialize the client sockets 
    if(!InitClientSocks()) 
    {
		AfxMessageBox("Can't build connection sockets!");
		return FALSE;
	}	

	// Initialize the server sockets
	if(!InitServSocks())
	{
		AfxMessageBox("Can't build server sockets!");
		return FALSE;
	}	

	// Fill the compatible protocol list
	char strProt[128]; 
	for(int iLoop = 0; iLoop < m_iWorkProt; iLoop++)
	{
        wsprintf(strProt, "%s:  %d", m_lpServSocks[iLoop].m_lpProtocolName, 
			     m_lpServSocks[iLoop].m_iConnects);
		m_ProtList.AddString(strProt); 
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}


/**************************************************************************
 * System menu commands                                                   *
 **************************************************************************/
void CTalkserverDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}


/**************************************************************************
 * Paint function                                                         *
 * If you add a minimize button to your dialog, you will need the code    *
 * below to draw the icon.  For MFC applications using the document/view  *
 * model, this is automatically done for you by the framework.            *
 **************************************************************************/
void CTalkserverDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


/**************************************************************************
 * The system calls this to obtain the cursor to display while the user   *
 * drags the minimized window.                                            *
 **************************************************************************/
HCURSOR CTalkserverDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


/**************************************************************************
 * Initialize the server sockets                                          *
 **************************************************************************/
BOOL CTalkserverDlg::InitServSocks(void) 
{
    unsigned long  sizeProtBuf = 0; 
    int            cNumProt;
    int            iLoop1;
	int            iLoop2;
    int            iAddrLen;
    WORD           wVersionRequested;
    WSADATA        wsaData;
    BOOL           bCastStat;

    // Load winsock dll
    wVersionRequested = MAKEWORD(1, 1);
    if(WSAStartup(wVersionRequested, &wsaData) != 0)
    {
        // ERROR
		return FALSE;
    }

    // Determine size of buffer needed
    if(EnumProtocols(NULL, NULL, &sizeProtBuf) != SOCKET_ERROR)
    {
        // ERROR
        return FALSE;
    }

    // Allocate buffer of appropriate size
    if((m_lpProtBuf = (LPPROTOCOL_INFO)VirtualAlloc(NULL,
        sizeProtBuf, MEM_COMMIT, PAGE_READWRITE)) == NULL)
    {
        // ERROR
        return FALSE;
    }

    // Enumerate numbers of protocols 
    if((cNumProt = EnumProtocols(NULL, m_lpProtBuf, 
	    &sizeProtBuf)) == SOCKET_ERROR)
    {
        // ERROR
        return FALSE;
    }
	
    // Allocate the buffer for server sockets
    if((m_lpServSocks = (LPVTSOCKET)VirtualAlloc(NULL, 
		cNumProt * sizeof(VTSOCKET), MEM_COMMIT,
        PAGE_READWRITE)) == NULL)
    {
        // ERROR
        return FALSE;
    }

    // Retrieve the worlable protocols
    for(iLoop1 = 0, iLoop2 = 0; iLoop1 < cNumProt; iLoop1++)
    {
        // Only want connection oriented protocols (UDP)
        if((m_lpProtBuf[iLoop1].dwServiceFlags & XP_CONNECTIONLESS) 
			== 0)  
        {
			//Set up the server sockets
			if(BuildServer(this->GetSafeHwnd(), &m_lpServSocks[iLoop2], 
			   &m_lpProtBuf[iLoop1]))
			{
	            iLoop2++;
			}
        }
    }

	// Store the numbers of workable protocol
    m_iWorkProt =  iLoop2;


    // Register with Name Spaces
    if((m_SAPSocket = socket(AF_IPX, SOCK_DGRAM, 
		NSPROTO_IPX + 4)) != INVALID_SOCKET)
    {
        // Find IPX address which we are bound to
        for(iLoop1 = 0; iLoop1 < m_iWorkProt; iLoop1++)
        {
            if(m_lpServSocks[iLoop1].m_iProtocol == NSPROTO_SPXII)
            {
		        // Initialize SAP data

				// 2: SAP response(network order)
		        m_vtSAPData.m_iOperation = 0x200;  
		        
				// Network order   
				m_vtSAPData.m_iService = VT_NETID; 

				// Service name
				strcpy(m_vtSAPData.m_sServName, "VOICE TALK");  

				// Copy address into SAP body
		        memcpy((void *)m_vtSAPData.m_sNetID,    
		               (void *)(m_lpServSocks[iLoop1].m_sockAddr.sa_data), 
		               12);

				// Hop count starts at zero
		        m_vtSAPData.m_iHops = 0;                 

				// SAP packets sent over IPX
		        m_SAPSockAddr.sa_family = AF_IPX;
				
                // SAP destination socket address is 0452.
		        Ascii2Hex("0452", (char *)&m_SAPSockAddr.sa_socket, 2);  	        

				// Bind to SAP socket
		        if(bind(m_SAPSocket, (PSOCKADDR)&m_SAPSockAddr, 
					    sizeof(SOCKADDR_IPX)) == SOCKET_ERROR)
		        {
		            // Error binding to SAP socket
					return FALSE;
		        }
		        else
		        {
		            // Build destination address for SAP's 
					// IPX header (broadcast)
		            m_SAPDestSockAddr.sa_family = AF_IPX;
		            Ascii2Hex("00000000",m_SAPDestSockAddr.sa_netnum, 4);
		            Ascii2Hex("FFFFFFFFFFFF", m_SAPDestSockAddr.sa_nodenum, 6);
		            Ascii2Hex("0452", (char *)&m_SAPDestSockAddr.sa_socket, 2);

	                // Setup socket to allow broadcasts
	                bCastStat = TRUE;
	                iAddrLen = sizeof(bCastStat);
	                setsockopt(m_SAPSocket, SOL_SOCKET, SO_BROADCAST, 
						       (char *)&bCastStat, sizeof(bCastStat));
		            sendto(m_SAPSocket, (char *)&m_vtSAPData, sizeof(m_vtSAPData), 
						   MSG_DONTROUTE, (struct sockaddr *)&m_SAPDestSockAddr, 
						   sizeof(m_SAPDestSockAddr));

		            // Set timer to send SAP packet every 60 seconds.
		            SetTimer(1, 60000, NULL);
		        }
                break;
            }
        }
    }

	return TRUE;
}


/**************************************************************************
 * Initialize the clients sockets                                         *
 **************************************************************************/
BOOL CTalkserverDlg::InitClientSocks(void)
{
    // First allocate Connected Sockets Heap
    if((m_hConnectHeap = HeapCreate(0, sizeof(VTSOCKET) * 5, 
		                 sizeof(VTSOCKET) * 100)) == NULL)
    {
        // ERROR
		return FALSE;
    }
    if((m_lpClientSocks = (LPVTSOCKET)HeapAlloc(m_hConnectHeap, 0, 
		           sizeof(VTSOCKET) * 5)) == NULL)
    {
        // ERROR
        return FALSE;
    }

	return TRUE;
}


/**************************************************************************
 * Remove the deregistered client name from client list                   *
 **************************************************************************/
void CTalkserverDlg::DeRegisterClient(char* sClientName)
{
    int iLoop;

    // Prepare the deregister name message
    m_vtMsgBuf->m_ucIdentity = VT_IDENTITY;
    m_vtMsgBuf->m_ucMsgType = VT_TEXT;
    m_vtMsgBuf->m_lLength = REALLEN(sClientName) + SIZEVTMSGHDR;
    m_vtMsgBuf->m_ucCmd = VTCMD_DEREGNAME;
    memcpy((void*)m_vtMsgBuf->m_pData, (void*)sClientName,
		   REALLEN(sClientName));


    // Send to every connected client 
	// whose status is SOCKET_AVAILABLE
    for(iLoop = 0; iLoop < m_iNextFree; iLoop++)
    {
        if(m_lpClientSocks[iLoop].m_iStatus 
			== VTSOCKET_AVAILABLE)
        {  
            // Send out the deregister name message
            SendVTMessage(m_lpClientSocks[iLoop].m_hSock, m_vtMsgBuf);
        }
    }
}


/**************************************************************************
 * Update protocol list                                                     *
 **************************************************************************/
void CTalkserverDlg::UpdateProtList(int index)
{
	int iReVal;
	char strProt[128]; 
	
	iReVal = m_ProtList.FindString(-1, 
		     m_lpServSocks[index].m_lpProtocolName);
	
	// Found nothing
    if(iReVal == LB_ERR)
		return;

    m_ProtList.DeleteString(iReVal);
    wsprintf(strProt, "%s:  %d", m_lpServSocks[index].m_lpProtocolName, 
			     m_lpServSocks[index].m_iConnects);
	m_ProtList.InsertString(iReVal, strProt); 
}


/**************************************************************************
 * Update client list                                                     *
 **************************************************************************/
void CTalkserverDlg::UpdateClientList(char* name, 
									  int status, char* peername)
{
    int index;
    char strClient[128];
    
	// Find the client
	index = m_ClientList.FindString(-1, name);

	// Found it
	if(index != LB_ERR)
	{
		m_ClientList.DeleteString(index);  
	}

	switch(status)
    {
		// The client disconnected
	    case VTSOCKET_CLOSED:
			 return; 
        
        // Build available client entry 
		case VTSOCKET_AVAILABLE:  
	         wsprintf(strClient, "%s  AVAILABLE", name);
	         break;

        // Build reqsession entry
		case VTSOCKET_REQSESSION: 
			 wsprintf(strClient, "%s  SESSION SETUP  %s", 
				      name, peername);
             break;
        
			 // Build in session entry
		case VTSOCKET_INSESSION: 
			 wsprintf(strClient, "%s  in SESSION", name);
             break;
	}

	m_ClientList.InsertString(index, strClient);
}


/**************************************************************************
 * Timer event                                                            *
 **************************************************************************/
void CTalkserverDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	// Send out SAP package
    sendto(m_SAPSocket, (char *)&m_vtSAPData, sizeof(m_vtSAPData), 
		   MSG_DONTROUTE, (struct sockaddr *)&m_SAPDestSockAddr, 
		   sizeof(m_SAPDestSockAddr));

	CDialog::OnTimer(nIDEvent);
}


/**************************************************************************
 * Response to the VTM_CONNECTED message                                  *
 **************************************************************************/
LONG CTalkserverDlg::OnVTConnected(WPARAM wparam, LPARAM lparam)
{
    int index, addrlen;

    // May have to increase our heap size
    if(m_iNextFree >= m_iMaxConnects)
    {
        if(HeapAlloc(m_hConnectHeap, 0, sizeof(VTSOCKET) * 5) == NULL)
        {
           // ERROR 
		   return 0L;
        }
        m_iMaxConnects += 5;  
    }

    // Find socket that connect is refering to
    index = 0;
    while(m_lpServSocks[index].m_hSock != wparam) 
		index++;

    // Lets keep track of our progress
    m_lpServSocks[index].m_iStatus = VTSOCKET_ACCEPTING;

    // If the address is bigger than a sockaddr struct.  
	// use the reserved byte to cover it.
    addrlen = sizeof(m_lpClientSocks[m_iNextFree].m_sockAddr) 
		      + sizeof(m_lpClientSocks[m_iNextFree].m_Reserved);

    // Accept the connect request
    if ((m_lpClientSocks[m_iNextFree].m_hSock = 
		 accept(m_lpServSocks[index].m_hSock, 
		 &m_lpClientSocks[m_iNextFree].m_sockAddr,
         &addrlen)) == INVALID_SOCKET)
    {
        // ERROR
		AfxMessageBox("Can not accept the client socket");
        return 0L;
    }
    
	// Set client socket state
	if(WSAAsyncSelect(m_lpClientSocks[m_iNextFree].m_hSock, 
		this->GetSafeHwnd(), VTM_DATAREADY, FD_READ | FD_CLOSE) 
		== SOCKET_ERROR)
    {
        // ERROR clean up connection
		closesocket(m_lpClientSocks[m_iNextFree].m_hSock);
		AfxMessageBox("Can not select the client socket");
        return 0L;
    }
    // Fill in socket structure for client socket
    m_lpClientSocks[m_iNextFree].m_iProtocol 
		= m_lpServSocks[index].m_iProtocol;

    m_lpClientSocks[m_iNextFree].m_iSockType 
		= m_lpServSocks[index].m_iSockType;
    
	m_lpClientSocks[m_iNextFree].m_iServSockIndex 
		= index;
    
	m_lpClientSocks[m_iNextFree++].m_iStatus
		= VTSOCKET_CONNECTED;
	
	// Increment protocol connection count and display
    m_lpServSocks[index].m_iConnects ++;
    
	// Don't forget to set server socket status back to listening
    m_lpServSocks[index].m_iStatus = VTSOCKET_LISTENING;

	//Update the protocol list
    UpdateProtList(index);
	
	return 1L;
}


/**************************************************************************
 * Response to the VTM_DATAREADY message                                  *
 **************************************************************************/
LONG CTalkserverDlg::OnVTDataReady(WPARAM wparam, LPARAM lparam)
{
    int iIndex1; 
	int iIndex2; 
	int iIndex3; 
    int byteRead;
	int iStrLen;

    
    // Find the appropriate socket...allow 
	// for the reuse of a closed socket handle
    for(iIndex1 = 0; iIndex1 < m_iNextFree; iIndex1++)
    {
        if((m_lpClientSocks[iIndex1].m_hSock == wparam) 
			&& (m_lpClientSocks[iIndex1].m_iStatus != VTSOCKET_CLOSED))
            break;
    }
	
    if(LOWORD(lparam) == FD_CLOSE)
    {
        // Socket closed notification--cleanup!
        closesocket(m_lpClientSocks[iIndex1].m_hSock);

        // Delete name from client list display
        UpdateClientList(m_lpClientSocks[iIndex1].m_sUserName, 
			             VTSOCKET_CLOSED, NULL);

        // Take name off of other clients' available list
        if(m_lpClientSocks[iIndex1].m_iStatus == VTSOCKET_AVAILABLE)
        {
            DeRegisterClient(m_lpClientSocks[iIndex1].m_sUserName);
        }

        // if this connection was in session with another peer...
		// notify peer of disconnect

        // First, find peer
        for(iIndex2 = 0; iIndex2 < m_iNextFree; iIndex2++)
        {
            if((m_lpClientSocks[iIndex2].m_hSock == 
				m_lpClientSocks[iIndex1].m_hPeerSock) &&
                (m_lpClientSocks[iIndex2].m_iStatus == 
				VTSOCKET_INSESSION))
            {
                break;
            }
        }
		// Did we find a peer?
        if(iIndex2 < m_iNextFree)  
        {
            // Yes, build message information
            m_vtMsgBuf->m_ucIdentity = VT_IDENTITY;
            m_vtMsgBuf->m_ucMsgType = VT_TEXT;
            m_vtMsgBuf->m_lLength = byteRead = SIZEVTMSGHDR;
            m_vtMsgBuf->m_ucCmd = VTCMD_SESSIONCLOSE;
            
			// Send session close message
            SendVTMessage(m_lpClientSocks[iIndex2].m_hSock, m_vtMsgBuf);
			
			// Update Peer's displayed status
            m_lpClientSocks[iIndex2].m_iStatus = VTSOCKET_AVAILABLE;
			UpdateClientList(m_lpClientSocks[iIndex2].m_sUserName, 
				             VTSOCKET_AVAILABLE, NULL);
			
			// Propagate the fact that the peer is now available for other chats
			// and give peer list of other available clients
            for(iIndex3 = 0; iIndex3 < m_iNextFree; iIndex3++)
            {
                if ((iIndex3 != iIndex2) && 
					(m_lpClientSocks[iIndex3].m_iStatus == VTSOCKET_AVAILABLE))
                {
                    m_vtMsgBuf->m_ucCmd = VTCMD_REGNAME;
                    memcpy((void*)m_vtMsgBuf->m_pData, 
						   (void*)m_lpClientSocks[iIndex3].m_sUserName,
						   REALLEN(m_lpClientSocks[iIndex3].m_sUserName)*sizeof(char));
                    m_vtMsgBuf->m_lLength = REALLEN(m_lpClientSocks[iIndex3].m_sUserName) 
						                 + SIZEVTMSGHDR;
                    SendVTMessage(m_lpClientSocks[iIndex2].m_hSock, m_vtMsgBuf);

                    memcpy((void*)m_vtMsgBuf->m_pData, 
						   (void*)m_lpClientSocks[iIndex2].m_sUserName,
						   REALLEN(m_lpClientSocks[iIndex2].m_sUserName)*sizeof(char));
                    m_vtMsgBuf->m_lLength = REALLEN(m_lpClientSocks[iIndex2].m_sUserName) 
						                   + SIZEVTMSGHDR;
                    SendVTMessage(m_lpClientSocks[iIndex3].m_hSock, m_vtMsgBuf);
                }
            }
        }
        // Cleanup the client sockets array
        m_lpClientSocks[iIndex1].m_iStatus = VTSOCKET_CLOSED;
        iIndex2 = m_lpClientSocks[iIndex1].m_iServSockIndex;
	    // Fix protocol connection count display
	    m_lpServSocks[iIndex2].m_iConnects --;

        UpdateProtList(iIndex2);

		return 1L;
    }


	// Read incoming message data
    if(!RecvVTMessage(&m_lpClientSocks[iIndex1], m_vtMsgBuf))
    {
        return 0L;
    }

    switch(m_vtMsgBuf->m_ucCmd)
    {
		// First message we should receive on a connection
        case VTCMD_REGNAME:  
            if(m_lpClientSocks[iIndex1].m_iStatus != VTSOCKET_CONNECTED)
            {
                // ERROR
                AfxMessageBox("The client not connected"); 
                return 0L;
            }
            

			// Get name and add to internal structs and display
            iStrLen = m_vtMsgBuf->m_lLength - SIZEVTMSGHDR; 
			memcpy((void*)m_lpClientSocks[iIndex1].m_sUserName, 
				   (void*)m_vtMsgBuf->m_pData, iStrLen+1);
            m_lpClientSocks[iIndex1].m_iStatus = VTSOCKET_AVAILABLE;
            
			UpdateClientList(m_lpClientSocks[iIndex1].m_sUserName, 
				    VTSOCKET_AVAILABLE, NULL);

            // Send notification to other "AVAILABLE" sockets that 
			// we have a new peer available
            for(iIndex2 = 0; iIndex2 < m_iNextFree; iIndex2++)
            {
                if ((iIndex2 != iIndex1) && 
					(m_lpClientSocks[iIndex2].m_iStatus == VTSOCKET_AVAILABLE))
                {
                    // message should be able to be sent just like it is
                    SendVTMessage(m_lpClientSocks[iIndex2].m_hSock, m_vtMsgBuf);
                }
            }

            // Send notifications back to registering peer of 
			// all the currently available peers
            for(iIndex2 = 0; iIndex2 < m_iNextFree; iIndex2++)
            {
                if ((iIndex2 != iIndex1) && 
					(m_lpClientSocks[iIndex2].m_iStatus == VTSOCKET_AVAILABLE))
                {
                    // found one...build message and send it
                    m_vtMsgBuf->m_ucCmd = VTCMD_REGNAME;
                    m_vtMsgBuf->m_ucMsgType = VT_TEXT;                    
					m_vtMsgBuf->m_lLength = REALLEN(m_lpClientSocks[iIndex2].m_sUserName) 
						                 + SIZEVTMSGHDR;
                    memcpy((void*)m_vtMsgBuf->m_pData, 
						   (void*)m_lpClientSocks[iIndex2].m_sUserName,
						   REALLEN(m_lpClientSocks[iIndex2].m_sUserName)*sizeof(char));
                    SendVTMessage(m_lpClientSocks[iIndex1].m_hSock, m_vtMsgBuf);
                }
            }

			return 1L;

        // For passing data between two insession peers
        case VTCMD_MSGDATA:  
            if(m_lpClientSocks[iIndex1].m_iStatus != VTSOCKET_INSESSION)
            {
                // ERROR 
                return 0L;
            }

            // forward the message to peer...should be able transfer
            // message without modification
            SendVTMessage(m_lpClientSocks[iIndex1].m_hPeerSock, m_vtMsgBuf);
            return 1L;

        // Client is asking another peer for a chat
        case VTCMD_REQSESSION:  
            if(m_lpClientSocks[iIndex1].m_iStatus != VTSOCKET_AVAILABLE)
            {
                // ERROR
				AfxMessageBox("Client not available!");
                return 0L;
            }

            m_lpClientSocks[iIndex1].m_iStatus = VTSOCKET_REQSESSION;
            UpdateClientList(m_lpClientSocks[iIndex1].m_sUserName, 
				             VTSOCKET_REQSESSION, (char*)m_vtMsgBuf->m_pData);

            // Find the socket which corresponds to the name

            for(iIndex2 = 0; iIndex2 < m_iNextFree; iIndex2++)
            {
                iStrLen = m_vtMsgBuf->m_lLength - SIZEVTMSGHDR; 
			    if(memcmp((void*)m_lpClientSocks[iIndex2].m_sUserName, 
				          (void*)m_vtMsgBuf->m_pData, iStrLen) == 0)
                {
                    if(m_lpClientSocks[iIndex2].m_iStatus == 
					   VTSOCKET_AVAILABLE)
                    {
                        // Found It!
                        break;
                    }
                }
            }

			// Found nothing
            if(iIndex2 == m_iNextFree) 
			{
				AfxMessageBox("Not find in VTCMD_REQSESSION"); 
				return 0L;
			}

            // Copy requester's name into send data buffer
            m_vtMsgBuf->m_lLength = REALLEN(m_lpClientSocks[iIndex1].m_sUserName) 
						                 + SIZEVTMSGHDR;
            memcpy((void*)m_vtMsgBuf->m_pData, 
						   (void*)m_lpClientSocks[iIndex1].m_sUserName,
						   REALLEN(m_lpClientSocks[iIndex1].m_sUserName)*sizeof(char));
            SendVTMessage(m_lpClientSocks[iIndex2].m_hSock, m_vtMsgBuf);

            // Update connected sockets structures
            m_lpClientSocks[iIndex2].m_iStatus = VTSOCKET_REQSESSION;
            UpdateClientList(m_lpClientSocks[iIndex2].m_sUserName, 
				       VTSOCKET_REQSESSION, m_lpClientSocks[iIndex1].m_sUserName);
            m_lpClientSocks[iIndex2].m_hPeerSock = m_lpClientSocks[iIndex1].m_hSock;
            m_lpClientSocks[iIndex1].m_hPeerSock = m_lpClientSocks[iIndex2].m_hSock;
            return 1L;

        // Response to session request
        case VTCMD_SESSIONREQRESP:  
            if(m_lpClientSocks[iIndex1].m_iStatus != VTSOCKET_REQSESSION)
            {
                // ERROR
                return 0L;
            }

            // find peer entry
            for(iIndex2 = 0; iIndex2 < m_iNextFree; iIndex2++)
            {
                if ((m_lpClientSocks[iIndex2].m_hSock == 
					 m_lpClientSocks[iIndex1].m_hPeerSock) 
					&& (m_lpClientSocks[iIndex2].m_iStatus == VTSOCKET_REQSESSION))
                {
                    // Found it!
                    break;
                }
            }

            if(iIndex2 == m_iNextFree)
            {
                // ERROR 
                return 0;
            }

            // forward response to requester
            SendVTMessage(m_lpClientSocks[iIndex1].m_hPeerSock, m_vtMsgBuf);

            if(m_vtMsgBuf->m_pData[0] == 1)
            {
                // Session accepted, change status of sockets
                m_lpClientSocks[iIndex1].m_iStatus = VTSOCKET_INSESSION;
                m_lpClientSocks[iIndex2].m_iStatus = VTSOCKET_INSESSION;
                
				UpdateClientList(m_lpClientSocks[iIndex1].m_sUserName, 
					VTSOCKET_INSESSION, m_lpClientSocks[iIndex2].m_sUserName);
				UpdateClientList(m_lpClientSocks[iIndex2].m_sUserName, 
					VTSOCKET_INSESSION, m_lpClientSocks[iIndex1].m_sUserName);
				
				DeRegisterClient(m_lpClientSocks[iIndex1].m_sUserName);
				DeRegisterClient(m_lpClientSocks[iIndex2].m_sUserName);
            }
            else
            {
                // Session not accepted, make sockets available
                m_lpClientSocks[iIndex1].m_iStatus = VTSOCKET_AVAILABLE;
                m_lpClientSocks[iIndex2].m_iStatus = VTSOCKET_AVAILABLE;
				UpdateClientList(m_lpClientSocks[iIndex1].m_sUserName, 
					VTSOCKET_AVAILABLE, NULL);
				UpdateClientList(m_lpClientSocks[iIndex2].m_sUserName, 
					VTSOCKET_AVAILABLE, NULL);
            }

            return 1L;
        
        // Insession client chose "End Chat" option 
		case VTCMD_SESSIONCLOSE:  
            if (m_lpClientSocks[iIndex1].m_iStatus != VTSOCKET_INSESSION)
            {
                // Can't close
                return 0L;
            }

            // Find Peer
            for(iIndex2 = 0; iIndex2 < m_iNextFree; iIndex2++)
            {
                if ((m_lpClientSocks[iIndex2].m_hSock == 
					 m_lpClientSocks[iIndex1].m_hPeerSock) 
					&& (m_lpClientSocks[iIndex2].m_iStatus == VTSOCKET_INSESSION))
                {
                    // Found it
                    break;
                }
            }

            if(iIndex2 == m_iNextFree)
            {
                // ERROR 
                return 0;
            }

            // forward message
            SendVTMessage(m_lpClientSocks[iIndex1].m_hPeerSock, m_vtMsgBuf);

            // Change Status
            m_lpClientSocks[iIndex1].m_iStatus = VTSOCKET_AVAILABLE;
            m_lpClientSocks[iIndex2].m_iStatus = VTSOCKET_AVAILABLE;
			UpdateClientList(m_lpClientSocks[iIndex1].m_sUserName, 
					VTSOCKET_AVAILABLE, NULL);
			UpdateClientList(m_lpClientSocks[iIndex2].m_sUserName, 
					VTSOCKET_AVAILABLE, NULL);

            // register names of both peers with other available clients.  Also
			// provide current available client names to both peers
            for(iIndex3 = 0; iIndex3 < m_iNextFree; iIndex3++)
            {
                if(m_lpClientSocks[iIndex3].m_iStatus == VTSOCKET_AVAILABLE)
                {
                    if(iIndex3 != iIndex1)
                    {
                        m_vtMsgBuf->m_ucIdentity = VT_IDENTITY;
                        m_vtMsgBuf->m_ucMsgType = VT_TEXT;
                        m_vtMsgBuf->m_ucCmd = VTCMD_REGNAME;
					    m_vtMsgBuf->m_lLength = REALLEN(m_lpClientSocks[iIndex1].m_sUserName) 
						                 + SIZEVTMSGHDR;
                        memcpy((void*)m_vtMsgBuf->m_pData, 
						       (void*)m_lpClientSocks[iIndex1].m_sUserName,
						       REALLEN(m_lpClientSocks[iIndex1].m_sUserName)*sizeof(char));
                        
						SendVTMessage(m_lpClientSocks[iIndex3].m_hSock, m_vtMsgBuf);

                        if (iIndex3 != iIndex2)
                        {
					        m_vtMsgBuf->m_lLength = REALLEN(m_lpClientSocks[iIndex3].m_sUserName) 
						                 + SIZEVTMSGHDR;
                            memcpy((void*)m_vtMsgBuf->m_pData, 
						       (void*)m_lpClientSocks[iIndex3].m_sUserName,
						       REALLEN(m_lpClientSocks[iIndex3].m_sUserName)*sizeof(char));

                            SendVTMessage(m_lpClientSocks[iIndex1].m_hSock, m_vtMsgBuf);
                        }
                    }
                    if(iIndex3 != iIndex2)
                    {
                        m_vtMsgBuf->m_ucIdentity = VT_IDENTITY;
                        m_vtMsgBuf->m_ucMsgType = VT_TEXT;
                        m_vtMsgBuf->m_ucCmd = VTCMD_REGNAME;
					    m_vtMsgBuf->m_lLength = REALLEN(m_lpClientSocks[iIndex2].m_sUserName) 
						                 + SIZEVTMSGHDR;
                        memcpy((void*)m_vtMsgBuf->m_pData, 
						       (void*)m_lpClientSocks[iIndex2].m_sUserName,
						       REALLEN(m_lpClientSocks[iIndex2].m_sUserName)*sizeof(char));

                        SendVTMessage(m_lpClientSocks[iIndex3].m_hSock, m_vtMsgBuf);

                        if(iIndex3 != iIndex1)
                        {
					        m_vtMsgBuf->m_lLength = REALLEN(m_lpClientSocks[iIndex3].m_sUserName) 
						                 + SIZEVTMSGHDR;
                            memcpy((void*)m_vtMsgBuf->m_pData, 
						       (void*)m_lpClientSocks[iIndex3].m_sUserName,
						       REALLEN(m_lpClientSocks[iIndex3].m_sUserName)*sizeof(char));

                            SendVTMessage(m_lpClientSocks[iIndex2].m_hSock, m_vtMsgBuf);
                        }
                    }
                }
            }
            return 1L;
		default:
			AfxMessageBox("NOTHING"); 
	}

	return 1L;
}

